package com.connor.jd.plm.dialogs;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.filechooser.FileNameExtensionFilter;

import com.connor.jd.operations.ExcelOperation;
import com.connor.jd.plm.utils.JDMethodUtil;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentProjectSmartFolder;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.ButtonLayout;
import com.teamcenter.rac.util.MessageBox;

public class QTXJCDialog extends AbstractAIFDialog {

	private AbstractAIFApplication app;
	private TCSession session;
	private JLabel road = new JLabel();
	private JComboBox<String> pjsName = new JComboBox<String>();
	private List<String> sfList = new ArrayList<String>();
	private TCComponent[] com;
	private String type;

	public QTXJCDialog(AbstractAIFApplication app, List<String> sfList, TCComponent[] com, TCSession session,
			String type) throws TCException {
		this.app = app;
		this.sfList = sfList;
		this.com = com;
		this.session = session;
		this.type = type;
		initUI();
	}

	private void initUI() {
		this.setAutoRequestFocus(true);
		this.setPreferredSize(new Dimension(360, 150));
		this.setResizable(false);

		JLabel pjStage = new JLabel("Ŀ׶");
		pjsName.addItem("");
		for (int i = 0; i < sfList.size(); i++) {
			pjsName.addItem(sfList.get(i));
		}
		JLabel roadLabel = new JLabel("·");

		JButton open = new JButton("...");
		open.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				openBtn();
			}
		});
		JButton export = new JButton("");
		export.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				exportBtn();
			}
		});
		JButton out = new JButton("ȡ");
		out.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		});
		JPanel flow1 = new JPanel();
		Box b1 = Box.createHorizontalBox();
		flow1.add(b1);
		// b1.add(Box.createHorizontalStrut(20));
		b1.add(pjStage);
		b1.add(Box.createHorizontalStrut(50));
		b1.add(pjsName);
		JPanel flow2 = new JPanel();
		Box b2 = Box.createHorizontalBox();
		flow2.add(b2);
		b2.add(Box.createHorizontalStrut(20));
		b2.add(roadLabel);
		b2.add(Box.createHorizontalStrut(20));
		b2.add(road);
		b2.add(Box.createHorizontalStrut(80));
		b2.add(open);
		JPanel btn = new JPanel(new ButtonLayout());
		btn.add(export);
		btn.add(out);
		JPanel center = new JPanel(new BorderLayout());
		center.add(flow1, BorderLayout.NORTH);
		center.add(flow2, BorderLayout.CENTER);
		center.add(btn, BorderLayout.SOUTH);
		this.add(center, "Center");

		this.pack();
		this.centerToScreen();
		this.showDialog();
	}

	String roadName = null;

	private void openBtn() {
		JFileChooser chooser = new JFileChooser();
		// chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		chooser.setDialogTitle("ѡҪļ");
		// chooser.showDialog(new JLabel(), "ȷ");

		FileNameExtensionFilter filter = new FileNameExtensionFilter("Excel(*.xlsx)", "xlsx");
		chooser.setFileFilter(filter);
		chooser.showSaveDialog(null);
		// File file = chooser.getSelectedFile();
		try {
			if (chooser.getSelectedFile().getAbsolutePath() != null) {
				String filePath = chooser.getSelectedFile().getAbsolutePath() + ".xlsx";
				roadName = filePath;
				if (filePath.length() > 10) {
					road.setText(filePath.substring(0, 10) + "...");
				} else {
					road.setText(filePath);
				}
			}

		} catch (Exception e) {
		}

	}

	private void exportBtn() {
		String jdname = "JDJFW";
		if (roadName.equals("")) {
			MessageBox.post("ûѡ񱣴·", "", MessageBox.ERROR);
		} else {
			System.out.println(road.getText());
			String outpath = roadName;

			System.out.println(outpath);

			File file = getExcle(jdname, type);
			String sel = (String) pjsName.getSelectedItem();
			Map<String, List<TCComponent>> jfw = new HashMap<String, List<TCComponent>>();
			if (sel.equals("")) {
				for (int i = 0; i < sfList.size(); i++) {
					TCComponentProjectSmartFolder sf = (TCComponentProjectSmartFolder) com[i];
					try {
						TCComponent[] psf = sf.getTCProperty("project_data").getReferenceValueArray();

						List<TCComponent> jfList = new ArrayList<TCComponent>();
						for (int j = 0; j < psf.length; j++) {
							// TCComponentItem jf = (TCComponentItem) psf[j];
							jfList.add(psf[j]);
						}
						jfw.put(sf.getProperty("object_string"), jfList);
					} catch (TCException e) {
						e.printStackTrace();
					}
				}
			} else {
				for (int i = 0; i < sfList.size(); i++) {
					TCComponentProjectSmartFolder sf = (TCComponentProjectSmartFolder) com[i];
					try {
						if (sel.equals(sf.getProperty("object_string"))) {
							TCComponent[] psf = sf.getTCProperty("project_data").getReferenceValueArray();
							List<TCComponent> jfList = new ArrayList<TCComponent>();
							for (int j = 0; j < psf.length; j++) {
								// TCComponentItem jf = (TCComponentItem) psf[j];
								jfList.add(psf[j]);
							}
							jfw.put(sel, jfList);
						}
					} catch (TCException e) {
						e.printStackTrace();
					}
				}
			}
			ExcelOperation.writeExcel(file, outpath, jfw);
			System.out.println("ɹ");
			MessageBox.post("ɹ", "Ϣ", MessageBox.INFORMATION);
			dispose();
		}
	}

	private File getExcle(String ssx, String type) {
		File fmsFile = null;
		String allpuid = JDMethodUtil.getPrefStr(ssx, session);
		String[] relpuid = allpuid.split(";");
		String puid = null;
		switch (type) {
		case "GT":
			puid = relpuid[2];
			break;
		case "BL":
			puid = relpuid[1];
			break;
		case "BX":
			puid = relpuid[0];
			break;
		default:
			break;
		}
		if (puid == null) {
			MessageBox.post("ϵԱѡ", "", MessageBox.ERROR);
			return null;
		}
		TCComponentDataset dateset = null;
		try {
			dateset = (TCComponentDataset) session.stringToComponent(puid);
		} catch (TCException e) {
			e.printStackTrace();
		}
		if (dateset == null) {
			MessageBox.post("δҵݼϵԱѡ", "", MessageBox.ERROR);
			return null;
		}
		try {
			TCComponentTcFile[] file = dateset.getTcFiles();
			if (file.length == 0 || file.length != 1) {
				MessageBox.post("ݼûõļļ࣬飡", "", MessageBox.WARNING);
				return null;
			} else {
				fmsFile = file[0].getFmsFile();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return fmsFile;
	}
//	@Override
//	public void start(Stage arg0) throws Exception {
//		Stage primaryStage = new Stage();
//		Pane root = new Pane();
//		Label pjStage = new Label("Ŀ׶");
//		pjStage.setLayoutX(37.0);
//		pjStage.setLayoutY(51.0);
//		ComboBox pjsName = new ComboBox();
//		pjsName.setLayoutX(94.0);
//		pjsName.setLayoutY(47.0);
//		pjsName.setValue("");
//		Label roadLabel = new Label("·");
//		roadLabel.setLayoutX(37.0);
//		roadLabel.setLayoutY(107.0);
//		Label road = new Label();
//		road.setLayoutX(94.0);
//		road.setLayoutY(107.0);
//		Button open = new Button("...");
//		open.setLayoutX(190.0);
//		open.setLayoutY(103.0);
//		Button export = new Button("");
//		export.setLayoutX(67.0);
//		export.setLayoutY(158.0);
//		Button out = new Button("ȡ");
//		out.setLayoutX(169.0);
//		out.setLayoutY(158.0);
//
//		root.getChildren().add(pjStage);
//		root.getChildren().add(pjsName);
//		root.getChildren().add(roadLabel);
//		root.getChildren().add(road);
//		root.getChildren().add(open);
//		root.getChildren().add(export);
//		root.getChildren().add(out);
//
//		Scene scene = new Scene(root, 290, 207);
//		primaryStage.setScene(scene);
//		primaryStage.setResizable(false);
//		primaryStage.show();
//	}

}
