package com.connor.jd.plm.handlers;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.connor.jd.plm.dialogs.QTXJCDialog;
import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentProject;
import com.teamcenter.rac.kernel.TCComponentProjectSmartFolder;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class QTXJCHandler extends AbstractHandler {

	private TCComponent[] com;

	@Override
	public Object execute(ExecutionEvent arg0) throws ExecutionException {
		List<String> sfList = new ArrayList<String>();
		String name = arg0.getCommand().getId();
		String type = null;
		switch (name) {
		case "JDProject.menus.JD2_GTQTXJC":
			type = "GT";
			break;
		case "JDProject.menus.JD2_BLQTXJC":
			type = "BL";
			break;
		case "JDProject.menus.JD2_BXQTXJC":
			type = "BX";
			break;
		default:
			break;
		}
		try {
			AbstractAIFUIApplication app = AIFUtility.getCurrentApplication();
			if (app.getTargetComponent() != null && app.getTargetComponent() instanceof TCComponentProject) {
				TCComponentProject project = (TCComponentProject) app.getTargetComponent();
				com = project.getTCProperty("project_data").getReferenceValueArray();
				for (int i = 0; i < com.length; i++) {
					TCComponentProjectSmartFolder sf = (TCComponentProjectSmartFolder) com[i];
					sfList.add(sf.getProperty("object_string"));
				}
				TCSession session = (TCSession) app.getSession();
				try {
					new Thread(new QTXJCDialog(app, sfList, com, session, type)).start();
				} catch (TCException e) {
					e.printStackTrace();
				}
			} else {
				MessageBox.post("ѡĿ", "ʾ", MessageBox.INFORMATION);
			}
		} catch (TCException e1) {
			e1.printStackTrace();
		}

		return null;
	}

}
