package com.connor.jd.plm.table;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JCheckBox;
import javax.swing.JPanel;

public class JCheckPanel extends JPanel {
	private JCheckBox[] buttons = null;

	public JCheckPanel(String[] text) {
		super();
		buttons = new JCheckBox[text.length];
		for (int i = 0; i < text.length; i++) {
			buttons[i] = new JCheckBox(text[i]);
			buttons[i].setPreferredSize(new Dimension(100, 25));
			add(buttons[i]);
		}
		setLayout(new FlowLayout(FlowLayout.LEFT));
	}

	public JCheckBox[] getButtons() {
		return buttons;
	}

	public List<JCheckBox> getSelected() {
		List<JCheckBox> list = new ArrayList<JCheckBox>();
		for (JCheckBox check : buttons) {
			if (check.isSelected()) {
				list.add(check);
			}
		}
		return list;
	}

	public void setSelected(int index) {
		buttons[index].setSelected(true);
	}

	public void setSelected(String value) {
		for (int i = 0; i < buttons.length; i++) {
			buttons[i].setSelected(buttons[i].getText().equals(value));
		}
	}
}
